#include <iostream>
#include <vector>

using namespace std;

struct Input
{
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data()
{
    Input in;
    size_t number_count;
    cin >> number_count;

    in.numbers.resize(number_count);

    for (size_t i = 0; i < number_count; i++)
    {
        cin >> in.numbers[i];
    }

    cin >> in.bin_count;
    return in;
}

void find_minmax(const vector<double>& numbers, double& min, double& max)
{
    min = numbers[0];
    for (double x : numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }
}

vector<double> make_histogram(const vector<double> &numbers, size_t bin_count)
{
    double min = numbers[0];
    double max = numbers[0];
    find_minmax(numbers, min, max);
    double bin_size = (max - min) / bin_count;
    vector<double>bins(bin_count);
    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }

    double b;
    for (size_t i = 0; i < bin_count-1; i++)
    {
        if (bins[i] > bins[i+1])
        {
            b = bins[i];
            bins[i] = bins[i + 1];
            bins[i + 1] = b;
        }
    }
    return bins;
}

void show_histogram_text(const vector <double> &bins)
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_STAR = SCREEN_WIDTH - 3 - 1;
    size_t max_star_search = bins[-1];

    if (max_star_search > MAX_STAR)
    {
        for (size_t x : bins)
        {
            size_t height = MAX_STAR * (static_cast<double>(x) / max_star_search);
            if (x < 100)
            {
                cout << " ";
                if (x < 10)
                {
                    cout << " ";
                }
            }
            cout << x << "|";
            for (size_t i = 0; i < height; i++)
            {
                cout << "*";
            }
            cout << endl;
        }
    }
    else
    {
        for (size_t x : bins)
        {
            if (x < 100)
            {
                cout << " ";
                if (x < 10)
                {
                    cout << " ";
                }
            }
            cout << x << "|";
            for (size_t i = 0; i < x; i++)
            {
                cout << "*";
            }
            cout << endl;
        }
    }
}

int main()
{
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins);
    return 0;
}
